diff -ur --unidirectional-new-file /usr/src/usr.sbin/inetd/inetd.c /usr/src-new/usr.sbin/inetd/inetd.c
--- /usr/src/usr.sbin/inetd/inetd.c	2006-01-13 14:26:46.000000000 -0600
+++ /usr/src-new/usr.sbin/inetd/inetd.c	2006-06-20 11:11:04.000000000 -0500
@@ -1134,80 +975,92 @@
 		*sepp = sep->se_next;
 		if (sep->se_fd >= 0)
 			close_sep(sep);
+		if (isrpcservice(sep))
+			unregister_rpc(sep);
+		if (sep->se_family == AF_LOCAL)
+			(void)unlink(sep->se_service);
 		if (debug)
 			print_service("FREE", sep);
-		if (sep->se_rpc && sep->se_rpc_prog > 0)
-			unregisterrpc(sep);
 		freeconfig(sep);
 		free(sep);
 	}
-	sigsetmask(omask);
 }
 
-void
-unregisterrpc(struct servtab *sep)
+static void
+retry(void)
 {
-        u_int i;
-        struct servtab *sepp;
-	long omask;
-
-	omask = sigblock(SIGBLOCK);
-        for (sepp = servtab; sepp; sepp = sepp->se_next) {
-                if (sepp == sep)
-                        continue;
-		if (sep->se_checked == 0 ||
-                    !sepp->se_rpc ||
-                    sep->se_rpc_prog != sepp->se_rpc_prog)
-			continue;
-                return;
-        }
-        if (debug)
-                print_service("UNREG", sep);
-        for (i = sep->se_rpc_lowvers; i <= sep->se_rpc_highvers; i++)
-                pmap_unset(sep->se_rpc_prog, i);
-        if (sep->se_fd != -1)
-                close(sep->se_fd);
-        sep->se_fd = -1;
-	sigsetmask(omask);
-}
+	struct servtab *sep;
 
-void
-flag_retry(int signo __unused)
-{
-	flag_signal('A');
+	timingout = 0;
+	for (sep = servtab; sep != NULL; sep = sep->se_next) {
+		if (sep->se_fd == -1 && !ISMUX(sep)) {
+			switch (sep->se_family) {
+			case AF_LOCAL:
+			case AF_INET:
+#ifdef INET6
+			case AF_INET6:
+#endif
+				setup(sep);
+				if (sep->se_fd != -1 && isrpcservice(sep))
+					register_rpc(sep);
+				break;
+			}
+		}
+	}
 }
 
-void
-retry(void)
+static void
+goaway(void)
 {
 	struct servtab *sep;
 
-	timingout = 0;
-	for (sep = servtab; sep; sep = sep->se_next)
-		if (sep->se_fd == -1 && !ISMUX(sep))
-			setup(sep);
+	for (sep = servtab; sep != NULL; sep = sep->se_next) {
+		if (sep->se_fd == -1)
+			continue;
+
+		switch (sep->se_family) {
+		case AF_LOCAL:
+			(void)unlink(sep->se_service);
+			break;
+		case AF_INET:
+#ifdef INET6
+		case AF_INET6:
+#endif
+			if (sep->se_wait == 1 && isrpcservice(sep))
+				unregister_rpc(sep);
+			break;
+		}
+		(void)close(sep->se_fd);
+	}
+	exit(0);
 }
 
-void
+
+static void
 setup(struct servtab *sep)
 {
-	int on = 1;
+	int		on = 1;
+#ifdef INET6
+	int		off = 0;
+#endif
+	struct kevent	*ev;
 
 	if ((sep->se_fd = socket(sep->se_family, sep->se_socktype, 0)) < 0) {
 		if (debug)
-			warn("socket failed on %s/%s",
-				sep->se_service, sep->se_proto);
+			fprintf(stderr, "socket failed on %s/%s: %s\n", 
+			    sep->se_service, sep->se_proto, strerror(errno));
 		syslog(LOG_ERR, "%s/%s: socket: %m",
 		    sep->se_service, sep->se_proto);
 		return;
 	}
 	/* Set all listening sockets to close-on-exec. */
 	if (fcntl(sep->se_fd, F_SETFD, FD_CLOEXEC) < 0) {
-		syslog(LOG_ERR, "%s/%s: fcntl (F_SETFD, FD_CLOEXEC): %m",
+		syslog(LOG_ERR, "%s/%s: fcntl(F_SETFD, FD_CLOEXEC): %m",
 		    sep->se_service, sep->se_proto);
 		close(sep->se_fd);
 		return;
 	}
+
 #define	turnon(fd, opt) \
 setsockopt(fd, SOL_SOCKET, opt, (char *)&on, sizeof (on))
 	if (strcmp(sep->se_proto, "tcp") == 0 && (options & SO_DEBUG) &&
@@ -1215,309 +1068,180 @@
 		syslog(LOG_ERR, "setsockopt (SO_DEBUG): %m");
 	if (turnon(sep->se_fd, SO_REUSEADDR) < 0)
 		syslog(LOG_ERR, "setsockopt (SO_REUSEADDR): %m");
-#ifdef SO_PRIVSTATE
-	if (turnon(sep->se_fd, SO_PRIVSTATE) < 0)
-		syslog(LOG_ERR, "setsockopt (SO_PRIVSTATE): %m");
-#endif
-	/* tftpd opens a new connection then needs more infos */
-	if ((sep->se_family == AF_INET6) &&
-	    (strcmp(sep->se_proto, "udp") == 0) &&
-	    (sep->se_accept == 0) &&
-	    (setsockopt(sep->se_fd, IPPROTO_IPV6, IPV6_PKTINFO,
-			(char *)&on, sizeof (on)) < 0))
-		syslog(LOG_ERR, "setsockopt (IPV6_RECVPKTINFO): %m");
-	if (sep->se_family == AF_INET6) {
-		int flag = sep->se_nomapped ? 1 : 0;
-		if (setsockopt(sep->se_fd, IPPROTO_IPV6, IPV6_V6ONLY,
-			       (char *)&flag, sizeof (flag)) < 0)
-			syslog(LOG_ERR, "setsockopt (IPV6_V6ONLY): %m");
-	}
 #undef turnon
-	if (sep->se_type == TTCP_TYPE)
-		if (setsockopt(sep->se_fd, IPPROTO_TCP, TCP_NOPUSH,
-		    (char *)&on, sizeof (on)) < 0)
-			syslog(LOG_ERR, "setsockopt (TCP_NOPUSH): %m");
-#ifdef IPV6_FAITH
-	if (sep->se_type == FAITH_TYPE) {
-		if (setsockopt(sep->se_fd, IPPROTO_IPV6, IPV6_FAITH, &on,
-				sizeof(on)) < 0) {
+
+	/* Set the socket buffer sizes, if specified. */
+	if (sep->se_sndbuf != 0 && setsockopt(sep->se_fd, SOL_SOCKET,
+	    SO_SNDBUF, (char *)&sep->se_sndbuf, sizeof(sep->se_sndbuf)) < 0)
+		syslog(LOG_ERR, "setsockopt (SO_SNDBUF %d): %m",
+		    sep->se_sndbuf);
+	if (sep->se_rcvbuf != 0 && setsockopt(sep->se_fd, SOL_SOCKET,
+	    SO_RCVBUF, (char *)&sep->se_rcvbuf, sizeof(sep->se_rcvbuf)) < 0)
+		syslog(LOG_ERR, "setsockopt (SO_RCVBUF %d): %m",
+		    sep->se_rcvbuf);
+#ifdef INET6
+	if (sep->se_family == AF_INET6) {
+		int *v;
+		v = (sep->se_type == FAITH_TYPE) ? &on : &off;
+		if (setsockopt(sep->se_fd, IPPROTO_IPV6, IPV6_FAITH,
+		    (char *)v, sizeof(*v)) < 0)
 			syslog(LOG_ERR, "setsockopt (IPV6_FAITH): %m");
-		}
 	}
 #endif
 #ifdef IPSEC
-	ipsecsetup(sep);
-#endif
-	if (sep->se_family == AF_UNIX) {
-		unlink(sep->se_ctrladdr_un.sun_path);
-		umask(0777); /* Make socket with conservative permissions */
+	if (ipsecsetup(sep->se_family, sep->se_fd, sep->se_policy) < 0 &&
+	    sep->se_policy) {
+		syslog(LOG_ERR, "%s/%s: ipsec setup failed",
+		    sep->se_service, sep->se_proto);
+		(void)close(sep->se_fd);
+		sep->se_fd = -1;
+		return;
 	}
-	if (bind(sep->se_fd, (struct sockaddr *)&sep->se_ctrladdr,
-	    sep->se_ctrladdr_size) < 0) {
+#endif
+
+	if (bind(sep->se_fd, &sep->se_ctrladdr, sep->se_ctrladdr_size) < 0) {
 		if (debug)
-			warn("bind failed on %s/%s",
-				sep->se_service, sep->se_proto);
+			fprintf(stderr, "bind failed on %s/%s: %s\n",
+			    sep->se_service, sep->se_proto, strerror(errno));
 		syslog(LOG_ERR, "%s/%s: bind: %m",
 		    sep->se_service, sep->se_proto);
-		close(sep->se_fd);
+		(void) close(sep->se_fd);
 		sep->se_fd = -1;
 		if (!timingout) {
 			timingout = 1;
 			alarm(RETRYTIME);
 		}
-		if (sep->se_family == AF_UNIX)
-			umask(mask);
 		return;
 	}
-	if (sep->se_family == AF_UNIX) {
-		/* Ick - fch{own,mod} don't work on Unix domain sockets */
-		if (chown(sep->se_service, sep->se_sockuid, sep->se_sockgid) < 0)
-			syslog(LOG_ERR, "chown socket: %m");
-		if (chmod(sep->se_service, sep->se_sockmode) < 0)
-			syslog(LOG_ERR, "chmod socket: %m");
-		umask(mask);
-	}
-        if (sep->se_rpc) {
-		u_int i;
-		socklen_t len = sep->se_ctrladdr_size;
-
-		if (sep->se_family != AF_INET) {
-                        syslog(LOG_ERR,
-			       "%s/%s: unsupported address family for rpc",
-                               sep->se_service, sep->se_proto);
-                        close(sep->se_fd);
-                        sep->se_fd = -1;
-                        return;
-		}
-                if (getsockname(sep->se_fd,
-				(struct sockaddr*)&sep->se_ctrladdr, &len) < 0){
-                        syslog(LOG_ERR, "%s/%s: getsockname: %m",
-                               sep->se_service, sep->se_proto);
-                        close(sep->se_fd);
-                        sep->se_fd = -1;
-                        return;
-                }
-                if (debug)
-                        print_service("REG ", sep);
-                for (i = sep->se_rpc_lowvers; i <= sep->se_rpc_highvers; i++) {
-                        pmap_unset(sep->se_rpc_prog, i);
-                        pmap_set(sep->se_rpc_prog, i,
-                                 (sep->se_socktype == SOCK_DGRAM)
-                                 ? IPPROTO_UDP : IPPROTO_TCP,
-				 ntohs(sep->se_ctrladdr4.sin_port));
-                }
-        }
 	if (sep->se_socktype == SOCK_STREAM)
-		listen(sep->se_fd, 64);
-	enable(sep);
-	if (debug) {
-		warnx("registered %s on %d",
-			sep->se_server, sep->se_fd);
-	}
-}
-
-#ifdef IPSEC
-void
-ipsecsetup(struct servtab *sep)
-{
-	char *buf;
-	char *policy_in = NULL;
-	char *policy_out = NULL;
-	int level;
-	int opt;
-
-	switch (sep->se_family) {
-	case AF_INET:
-		level = IPPROTO_IP;
-		opt = IP_IPSEC_POLICY;
-		break;
-#ifdef INET6
-	case AF_INET6:
-		level = IPPROTO_IPV6;
-		opt = IPV6_IPSEC_POLICY;
-		break;
-#endif
-	default:
-		return;
-	}
+		listen(sep->se_fd, 10);
 
-	if (!sep->se_policy || sep->se_policy[0] == '\0') {
-		static char def_in[] = "in entrust", def_out[] = "out entrust";
-		policy_in = def_in;
-		policy_out = def_out;
-	} else {
-		if (!strncmp("in", sep->se_policy, 2))
-			policy_in = sep->se_policy;
-		else if (!strncmp("out", sep->se_policy, 3))
-			policy_out = sep->se_policy;
-		else {
-			syslog(LOG_ERR, "invalid security policy \"%s\"",
-				sep->se_policy);
-			return;
-		}
-	}
-
-	if (policy_in != NULL) {
-		buf = ipsec_set_policy(policy_in, strlen(policy_in));
-		if (buf != NULL) {
-			if (setsockopt(sep->se_fd, level, opt,
-					buf, ipsec_get_policylen(buf)) < 0 &&
-			    debug != 0)
-				warnx("%s/%s: ipsec initialization failed; %s",
-				      sep->se_service, sep->se_proto,
-				      policy_in);
-			free(buf);
-		} else
-			syslog(LOG_ERR, "invalid security policy \"%s\"",
-				policy_in);
-	}
-	if (policy_out != NULL) {
-		buf = ipsec_set_policy(policy_out, strlen(policy_out));
-		if (buf != NULL) {
-			if (setsockopt(sep->se_fd, level, opt,
-					buf, ipsec_get_policylen(buf)) < 0 &&
-			    debug != 0)
-				warnx("%s/%s: ipsec initialization failed; %s",
-				      sep->se_service, sep->se_proto,
-				      policy_out);
-			free(buf);
-		} else
-			syslog(LOG_ERR, "invalid security policy \"%s\"",
-				policy_out);
+	ev = allocchange();
+	EV_SET(ev, sep->se_fd, EVFILT_READ, EV_ADD | EV_ENABLE, 0, 0,
+	    (intptr_t)sep);
+	if (sep->se_fd > maxsock) {
+		maxsock = sep->se_fd;
+		if (maxsock > rlim_ofile_cur - FD_MARGIN)
+			bump_nofile();
 	}
+	if (debug)
+		fprintf(stderr, "registered %s on %d\n",
+		    sep->se_server, sep->se_fd);
 }
-#endif
 
 /*
  * Finish with a service and its socket.
  */
-void
+static void
 close_sep(struct servtab *sep)
 {
 	if (sep->se_fd >= 0) {
-		if (FD_ISSET(sep->se_fd, &allsock))
-			disable(sep);
-		close(sep->se_fd);
+		(void) close(sep->se_fd);
 		sep->se_fd = -1;
 	}
 	sep->se_count = 0;
-	sep->se_numchild = 0;	/* forget about any existing children */
 }
 
-int
-matchservent(const char *name1, const char *name2, const char *proto)
+static void
+register_rpc(struct servtab *sep)
+{
+#ifdef RPC
+	socklen_t n;
+	struct netbuf nbuf;
+	struct sockaddr_storage ss;
+	struct netconfig *nconf;
+
+	if ((nconf = getnetconfigent(sep->se_proto+4)) == NULL) {
+		syslog(LOG_ERR, "%s: getnetconfigent failed",
+		    sep->se_proto);
+		return;
+	}
+	n = sizeof ss;
+	if (getsockname(sep->se_fd, (struct sockaddr *)&ss, &n) < 0) {
+		syslog(LOG_ERR, "%s/%s: getsockname: %m",
+		    sep->se_service, sep->se_proto);
+		return;
+	}
+
+	nbuf.buf = &ss;
+	nbuf.len = ss.ss_len;
+	nbuf.maxlen = sizeof (struct sockaddr_storage);
+	for (n = sep->se_rpcversl; n <= sep->se_rpcversh; n++) {
+		if (debug)
+			fprintf(stderr, "rpcb_set: %u %d %s %s\n",
+			    sep->se_rpcprog, n, nconf->nc_netid,
+			    taddr2uaddr(nconf, &nbuf));
+		(void)rpcb_unset(sep->se_rpcprog, n, nconf);
+		if (!rpcb_set(sep->se_rpcprog, n, nconf, &nbuf))
+			syslog(LOG_ERR, "rpcb_set: %u %d %s %s%s",
+			    sep->se_rpcprog, n, nconf->nc_netid,
+			    taddr2uaddr(nconf, &nbuf), clnt_spcreateerror(""));
+	}
+#endif /* RPC */
+}
+
+static void
+unregister_rpc(struct servtab *sep)
 {
-	char **alias, *p;
-	struct servent *se;
+#ifdef RPC
+	int n;
+	struct netconfig *nconf;
+
+	if ((nconf = getnetconfigent(sep->se_proto+4)) == NULL) {
+		syslog(LOG_ERR, "%s: getnetconfigent failed",
+		    sep->se_proto);
+		return;
+	}
 
-	if (strcmp(proto, "unix") == 0) {
-		if ((p = strrchr(name1, '/')) != NULL)
-			name1 = p + 1;
-		if ((p = strrchr(name2, '/')) != NULL)
-			name2 = p + 1;
-	}
-	if (strcmp(name1, name2) == 0)
-		return(1);
-	if ((se = getservbyname(name1, proto)) != NULL) {
-		if (strcmp(name2, se->s_name) == 0)
-			return(1);
-		for (alias = se->s_aliases; *alias; alias++)
-			if (strcmp(name2, *alias) == 0)
-				return(1);
+	for (n = sep->se_rpcversl; n <= sep->se_rpcversh; n++) {
+		if (debug)
+			fprintf(stderr, "rpcb_unset(%u, %d, %s)\n",
+			    sep->se_rpcprog, n, nconf->nc_netid);
+		if (!rpcb_unset(sep->se_rpcprog, n, nconf))
+			syslog(LOG_ERR, "rpcb_unset(%u, %d, %s) failed\n",
+			    sep->se_rpcprog, n, nconf->nc_netid);
 	}
-	return(0);
+#endif /* RPC */
 }
 
-struct servtab *
+
+static struct servtab *
 enter(struct servtab *cp)
 {
 	struct servtab *sep;
-	long omask;
 
 	sep = (struct servtab *)malloc(sizeof (*sep));
-	if (sep == (struct servtab *)0) {
-		syslog(LOG_ERR, "malloc: %m");
-		exit(EX_OSERR);
+	if (sep == NULL) {
+		syslog(LOG_ERR, "Out of memory.");
+		exit(1);
 	}
 	*sep = *cp;
 	sep->se_fd = -1;
-	omask = sigblock(SIGBLOCK);
+	sep->se_rpcprog = -1;
 	sep->se_next = servtab;
 	servtab = sep;
-	sigsetmask(omask);
 	return (sep);
 }
 
-void
-enable(struct servtab *sep)
-{
-	if (debug)
-		warnx(
-		    "enabling %s, fd %d", sep->se_service, sep->se_fd);
-#ifdef SANITY_CHECK
-	if (sep->se_fd < 0) {
-		syslog(LOG_ERR,
-		    "%s: %s: bad fd", __func__, sep->se_service);
-		exit(EX_SOFTWARE);
-	}
-	if (ISMUX(sep)) {
-		syslog(LOG_ERR,
-		    "%s: %s: is mux", __func__, sep->se_service);
-		exit(EX_SOFTWARE);
-	}
-	if (FD_ISSET(sep->se_fd, &allsock)) {
-		syslog(LOG_ERR,
-		    "%s: %s: not off", __func__, sep->se_service);
-		exit(EX_SOFTWARE);
-	}
-	nsock++;
-#endif
-	FD_SET(sep->se_fd, &allsock);
-	if (sep->se_fd > maxsock)
-		maxsock = sep->se_fd;
-}
-
-void
-disable(struct servtab *sep)
-{
-	if (debug)
-		warnx(
-		    "disabling %s, fd %d", sep->se_service, sep->se_fd);
-#ifdef SANITY_CHECK
-	if (sep->se_fd < 0) {
-		syslog(LOG_ERR,
-		    "%s: %s: bad fd", __func__, sep->se_service);
-		exit(EX_SOFTWARE);
-	}
-	if (ISMUX(sep)) {
-		syslog(LOG_ERR,
-		    "%s: %s: is mux", __func__, sep->se_service);
-		exit(EX_SOFTWARE);
-	}
-	if (!FD_ISSET(sep->se_fd, &allsock)) {
-		syslog(LOG_ERR,
-		    "%s: %s: not on", __func__, sep->se_service);
-		exit(EX_SOFTWARE);
-	}
-	if (nsock == 0) {
-		syslog(LOG_ERR, "%s: nsock=0", __func__);
-		exit(EX_SOFTWARE);
-	}
-	nsock--;
-#endif
-	FD_CLR(sep->se_fd, &allsock);
-	if (sep->se_fd == maxsock)
-		maxsock--;
-}
-
 FILE	*fconfig = NULL;
 struct	servtab serv;
 char	line[LINE_MAX];
+char    *defhost;
+#ifdef IPSEC
+static char *policy = NULL;
+#endif
 
-int
+static int
 setconfig(void)
 {
-
+	if (defhost)
+		free(defhost);
+	defhost = newstr("*");
+#ifdef IPSEC
+	if (policy)
+		free(policy);
+	policy = NULL;
+#endif
 	if (fconfig != NULL) {
 		fseek(fconfig, 0L, SEEK_SET);
 		return (1);
@@ -1526,109 +1250,122 @@
 	return (fconfig != NULL);
 }
 
-void
+static void
 endconfig(void)
 {
-	if (fconfig) {
-		fclose(fconfig);
+	if (fconfig != NULL) {
+		(void) fclose(fconfig);
 		fconfig = NULL;
 	}
+	if (defhost != NULL) {
+		free(defhost);
+		defhost = NULL;
+	}
 }
 
-struct servtab *
+static struct servtab *
 getconfigent(void)
 {
 	struct servtab *sep = &serv;
-	int argc;
-	char *cp, *arg, *s;
-	char *versp;
+	int argc, val;
+	char *cp, *cp0, *arg, *buf0, *buf1, *sz0, *sz1;
 	static char TCPMUX_TOKEN[] = "tcpmux/";
 #define MUX_LEN		(sizeof(TCPMUX_TOKEN)-1)
-#ifdef IPSEC
-	char *policy = NULL;
-#endif
-	int v4bind = 0;
-#ifdef INET6
-	int v6bind = 0;
-#endif
-	int i;
+	char *hostdelim;
 
 more:
-	while ((cp = nextline(fconfig)) != NULL) {
+	while ((cp = nextline(fconfig))) {
 #ifdef IPSEC
 		/* lines starting with #@ is not a comment, but the policy */
 		if (cp[0] == '#' && cp[1] == '@') {
 			char *p;
-			for (p = cp + 2; p && *p && isspace(*p); p++)
+			for (p = cp + 2; p && *p && isspace((unsigned char)*p); p++)
 				;
 			if (*p == '\0') {
 				if (policy)
 					free(policy);
 				policy = NULL;
-			} else if (ipsec_get_policylen(p) >= 0) {
-				if (policy)
-					free(policy);
-				policy = newstr(p);
 			} else {
-				syslog(LOG_ERR,
-					"%s: invalid ipsec policy \"%s\"",
-					CONFIG, p);
-				exit(EX_CONFIG);
+				if (ipsecsetup_test(p) < 0) {
+					syslog(LOG_ERR,
+						"%s: invalid ipsec policy \"%s\"",
+						CONFIG, p);
+					exit(1);
+				} else {
+					if (policy)
+						free(policy);
+					policy = newstr(p);
+				}
 			}
 		}
 #endif
 		if (*cp == '#' || *cp == '\0')
 			continue;
+#ifdef MULOG
+		/* Avoid use of `skip' if there is a danger of it looking
+		 * at continuation lines.
+		 */
+		do {
+			cp++;
+		} while (*cp == ' ' || *cp == '\t');
+		if (*cp == '\0')
+			continue;
+		if ((arg = skip(&cp)) == NULL)
+			continue;
+		if (strcmp(arg, "DOMAIN"))
+			continue;
+		if (curdom)
+			free(curdom);
+		curdom = NULL;
+		while (*cp == ' ' || *cp == '\t')
+			cp++;
+		if (*cp == '\0')
+			continue;
+		arg = cp;
+		while (*cp && *cp != ' ' && *cp != '\t')
+			cp++;
+		if (*cp != '\0')
+			*cp++ = '\0';
+		curdom = newstr(arg);
+#endif
 		break;
 	}
 	if (cp == NULL)
-		return ((struct servtab *)0);
+		return (NULL);
 	/*
 	 * clear the static buffer, since some fields (se_ctrladdr,
 	 * for example) don't get initialized here.
 	 */
-	memset(sep, 0, sizeof *sep);
+	memset((caddr_t)sep, 0, sizeof *sep);
 	arg = skip(&cp);
 	if (cp == NULL) {
 		/* got an empty line containing just blanks/tabs. */
 		goto more;
 	}
-	if (arg[0] == ':') { /* :user:group:perm: */
-		char *user, *group, *perm;
-		struct passwd *pw;
-		struct group *gr;
-		user = arg+1;
-		if ((group = strchr(user, ':')) == NULL) {
-			syslog(LOG_ERR, "no group after user '%s'", user);
-			goto more;
-		}
-		*group++ = '\0';
-		if ((perm = strchr(group, ':')) == NULL) {
-			syslog(LOG_ERR, "no mode after group '%s'", group);
-			goto more;
-		}
-		*perm++ = '\0';
-		if ((pw = getpwnam(user)) == NULL) {
-			syslog(LOG_ERR, "no such user '%s'", user);
-			goto more;
-		}
-		sep->se_sockuid = pw->pw_uid;
-		if ((gr = getgrnam(group)) == NULL) {
-			syslog(LOG_ERR, "no such user '%s'", group);
-			goto more;
-		}
-		sep->se_sockgid = gr->gr_gid;
-		sep->se_sockmode = strtol(perm, &arg, 8);
-		if (*arg != ':') {
-			syslog(LOG_ERR, "bad mode '%s'", perm);
-			goto more;
+	/* Check for a host name. */
+	hostdelim = strrchr(arg, ':');
+	if (hostdelim) {
+		*hostdelim = '\0';
+		if (arg[0] == '[' && hostdelim > arg && hostdelim[-1] == ']') {
+			hostdelim[-1] = '\0';
+			sep->se_hostaddr = newstr(arg + 1);
+		} else
+			sep->se_hostaddr = newstr(arg);
+		arg = hostdelim + 1;
+		/*
+		 * If the line is of the form `host:', then just change the
+		 * default host for the following lines.
+		 */
+		if (*arg == '\0') {
+			arg = skip(&cp);
+			if (cp == NULL) {
+				free(defhost);
+				defhost = sep->se_hostaddr;
+				goto more;
+			}
 		}
-		*arg++ = '\0';
-	} else {
-		sep->se_sockuid = euid;
-		sep->se_sockgid = egid;
-		sep->se_sockmode = 0200;
-	}
+	} else
+		sep->se_hostaddr = newstr(defhost);
 	if (strncmp(arg, TCPMUX_TOKEN, MUX_LEN) == 0) {
 		char *c = arg + MUX_LEN;
 		if (*c == '+') {
@@ -1641,6 +1378,7 @@
 		sep->se_service = newstr(arg);
 		sep->se_type = NORM_TYPE;
 	}
+
 	arg = sskip(&cp);
 	if (strcmp(arg, "stream") == 0)
 		sep->se_socktype = SOCK_STREAM;
